<?php

require_once dirname(__FILE__) . '/../../classes/Teqpay.php';
require_once dirname(__FILE__) . '/../../classes/Transaction.php';

class payment_teqpayajaxModuleFrontController extends ModuleFrontController
{
    public function initContent()
    {
        parent::initContent();
        $currency = new Currency($this->context->cart->id_currency);
        $cart = $this->context->cart;

        if (!$this->module->checkCurrency($cart))
            Tools::redirect('index.php?controller=order');

        $order_info                     = $this->context->cart;

        if( Tools::getValue('getInstallments') ){
            $card_number = Tools::getValue('card');

            if( strlen( $card_number ) > 6 )
                $card_number = substr($card_number, 0, 6);

            $teqpay = new Teqpay(
                Configuration::get('payment_teqpay_apiKey'),
                Configuration::get('payment_teqpay_secretKey'),
                Configuration::get('payment_teqpay_env'),
                Configuration::get('payment_teqpay_debug')
            );

            $teqpay->debug = false;
            $total = number_format($order_info->getOrderTotal(true), 2, '.', '');
            $rates = $teqpay->getInstallmentInfo($card_number, $total);
            $taksitler = []; 
            if( $rates["status"] != "error" AND count($rates["data"] ) ){
                foreach( $rates["data"] as $bankTaksit ){
                    $vade  = $bankTaksit->Installment;
                    //if( !in_array($vade, $teqpay_installments) )
                      //  continue;
                    $toplam = $bankTaksit->TotalPrice;
                    $aylik = $bankTaksit->AmountToPaid;
                    $taksitler[ $vade ] = [
                        'taksit' => $vade,
                        'aylik'  => $aylik,
                        'toplam' => $toplam,
                        'text'   => $vade . " x " . $aylik . ", Toplam : ". $toplam
                    ];
                }
            }


            echo json_encode(["status" => "success", "taksitler" => $taksitler]);
            exit;
        }
}
}
