<?php

require_once dirname(__FILE__) . '/../../classes/Teqpay.php';
require_once dirname(__FILE__) . '/../../classes/Transaction.php';

class payment_teqpayvalidationModuleFrontController extends ModuleFrontController
{
    /**
     * @see FrontController::postProcess()
     */
    public function postProcess()
    {

        $cart = $this->context->cart;
        if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active) {

            //dump($this->context);exit;
            Tools::redirect('index.php?controller=order&step=1');
        }

        // Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
        $authorized = false;
        foreach (Module::getPaymentModules() as $module) {
            if ($module['name'] == 'payment_teqpay') {
                $authorized = true;
                break;
            }
        }

        if (!$authorized) {
            die($this->module->l('This payment method is not available.', 'validation'));
        }

        $teqpay = new Teqpay(
            Configuration::get('payment_teqpay_apiKey'),
            Configuration::get('payment_teqpay_secretKey'),
            Configuration::get('payment_teqpay_env'),
            Configuration::get('payment_teqpay_debug')
        );
        
        $transaction =  Transaction::getOrderReferenceNo( $cart->id );
        $payment_control = $teqpay->checkPaymentStatus( end($transaction)['transactionId'] );
        
        if( $payment_control["status"] != "success" ){
            $this->context->controller->errors[] = $payment_control["message"];
            $this->context->controller->redirectWithNotifications(
                'order'
            );
        }else{
            //dump([$_GET, $_POST, $this->context]);exit;
            $customer = new Customer($this->context->customer->id);
            if (!Validate::isLoadedObject($customer))
                Tools::redirect('index.php?controller=order&step=1');
            $currency = $this->context->currency;
            $total = (float)$cart->getOrderTotal(true, Cart::BOTH);
            $mailVars = array(
                //'{payment_total}' => Tools::getValue('paymnt_total'),
            );

            $customer_secure_key = false;
            if( $customer AND $customer->secure_key)
                $customer_secure_key = $customer->secure_key;


            //dump([$_GET, $_POST, $this->context]);exit;
            $this->module->validateOrder($cart->id, Configuration::get('PS_OS_PAYMENT'), $total, $this->module->displayName, NULL, $mailVars, (int)$currency->id, false, $customer_secure_key);
            Tools::redirect('index.php?controller=order-confirmation&id_cart=' . $cart->id . '&id_module=' . $this->module->id . '&id_order=' . $this->module->currentOrder . '&key=' . $customer_secure_key);
        }
    }
}
